//  Ambrose3d 1.0
// 
// Copyright (C) 2007 Jari Komppa
//
// This software is provided 'as-is', without any express or implied
// warranty.  In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//    claim that you wrote the original software. If you use this software
//    in a product, an acknowledgment in the product documentation would be
//    appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//    misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.
//
// Jari Komppa jari.komppa@gmail.com, http://iki.fi/sol/
//  
// If you use this software for something, credits are appreciated but not mandatory.

//
// Ambrose3D "main" header file
// Includes everything needed
//
#ifndef AMBROSE_H
#define AMBROSE_H

#include <SDL.h>
#include "glee.h"
#include <GL/glu.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "FileHelpers.h"
#include "LoadTexture.h"
#include "VertexBuffer.h"

struct matrix4x4
{
    float v[4*4];
};

struct rgbcolor
{
    float r,g,b;
};

#include "AmbroseScene.h"
#include "AmbroseTexture.h"
#include "AmbroseObject.h"
#include "AmbroseTextureSlot.h"
#include "AmbroseMaterial.h"
#include "AmbroseMesh.h"
#include "AmbroseLight.h"
#include "AmbroseCamera.h"
#include "AmbroseAnimation.h"

#endif