//
// Material class
//
#ifndef AMBROSEMATERIAL_H
#define AMBROSEMATERIAL_H

class AmbroseTextureSlot;
class AmbroseScene;

class AmbroseMaterial 
{
public:
    // CTor
    AmbroseMaterial();
    // DTor
    virtual ~AmbroseMaterial();
    // Material ID
    int mId;
    // Material name
    char *mName;
    // Transparency of material (0..1)
    float mAlpha;
    // Diffuse color of material
    rgbcolor mDiffuse;
    // Specular color of material
    rgbcolor mSpecular; 
    // Texture material slots
    AmbroseTextureSlot *mSlot[8];
    // Load material from file
    int load(AmbroseScene *aScene, FILE *f);
};

#endif