// Vertex buffer class
// Wrapper for OpenGL arrays / VBOs
// If vertex buffer objects are not available, falls back to arrays

#ifndef VERTEXBUFFER_H
#define VERTEXBUFFER_H

class VertexBuffer
{
public:
    int mIndices;
    int mVertices;
    int mPrimitiveType;
    unsigned int mVertexVBO, mNormalVBO, mTexCoordVBO[4], mIndexVBO;

    GLfloat * mVertex;
    GLfloat * mNormal;
    GLfloat * mTexcoord[4];
    GLuint * mIndex;

    // Sets up pointers for rendering
    void activate();

    // Renders the contents of this vertex buffer
    void render();

    // Visualize normals (for debugging)
    void render_normals(float aScale = 0.2f);

    // CTor
    VertexBuffer();

    // DTor
    ~VertexBuffer();

    // Copies vertex arrays to VBOs if available.
    void optimize();
};

#endif