#include "Ambrose.h"

AmbroseAnimation::AmbroseAnimation()
{
    mId = 0;
    mFrame = NULL;
    mTargetPtr = NULL;  
}

AmbroseAnimation::~AmbroseAnimation()
{
    mId = 0;
    delete[] mFrame;
    mFrame = NULL;
    mTargetPtr = NULL;  
}

int AmbroseAnimation::load(AmbroseScene *aScene, FILE *f)
{
    mId = readInt(f);
    // Find animation target by id
    mTargetPtr = &(aScene->find(mId)->mMatrix);
    if (mTargetPtr == NULL)
        return 0;

    // Allocate memory for the animation
    mFrame = new matrix4x4[aScene->mFrames];
    if (mFrame == NULL)
        return 0;

    // Read the matrices
    int i, j;
    for (i = 0; i < aScene->mFrames; i++)
        for (j = 0; j < 4 * 4; j++)
            mFrame[i].v[j] = readFloat(f);  
    return 1;
}
