#include "Ambrose.h"

AmbroseMaterial::AmbroseMaterial()
{
    mId = 0;
    mName = NULL;
    int i;
    for (i = 0; i < 8; i++)
    {
        mSlot[i] = NULL;
    }
}

AmbroseMaterial::~AmbroseMaterial()
{
    mId = 0;
    delete[] mName;
    mName = NULL;
    int i;
    for (i = 0; i < 8; i++)
    { 
        delete mSlot[i];
        mSlot[i] = NULL;
    }
}

int AmbroseMaterial::load(AmbroseScene *aScene, FILE *f)
{
    mName = readAsciizString(f);
    mAlpha = readFloat(f);
    mDiffuse.r = readFloat(f);
    mDiffuse.g = readFloat(f);
    mDiffuse.b = readFloat(f);
    mSpecular.r = readFloat(f);
    mSpecular.g = readFloat(f);
    mSpecular.b = readFloat(f);
    int slots = readInt(f);
    if (slots < 0 || slots > 8)
        return 0;
    int i;
    for (i = 0; i < slots; i++)
    {
        mSlot[i] = new AmbroseTextureSlot();
        if (mSlot[i] == NULL)
            return 0;
        mSlot[i]->load(aScene, f);
    }
    return 1;
}
