#include "Ambrose.h"

AmbroseMesh::AmbroseMesh()
{
    mMaterial = NULL;
}

AmbroseMesh::~AmbroseMesh()
{
    mMaterial = NULL;
}

int AmbroseMesh::load(AmbroseScene *aScene, FILE *f)
{
    int i;
    if (!AmbroseObject::load(aScene, f))
        return 0;

    int materialid = readInt(f);
    mMaterial = aScene->findMaterial(materialid);

    mVB.mVertices = readInt(f);
    mVB.mIndices = readInt(f) * 3;

    mVB.mVertex = new float[mVB.mVertices * 3];
    if (mVB.mVertex == NULL)
        return 0;
    for (i = 0; i < mVB.mVertices * 3; i++)
        mVB.mVertex[i] = readFloat(f);

    mVB.mNormal = new float[mVB.mVertices * 3];
    if (mVB.mNormal == NULL)
        return 0;
    for (i = 0; i < mVB.mVertices * 3; i++)
        mVB.mNormal[i] = readFloat(f);

    mVB.mTexcoord[0] = new float[mVB.mVertices * 2];
    if (mVB.mTexcoord[0] == NULL)
        return 0;
    for (i = 0; i < mVB.mVertices * 2; i++)
        mVB.mTexcoord[0][i] = readFloat(f);

    mVB.mIndex = new unsigned int[mVB.mIndices];
    if (mVB.mIndex == NULL)
        return 0;
    for (i = 0; i < mVB.mIndices; i++)
        mVB.mIndex[i] = readInt(f);

    mVB.mPrimitiveType = GL_TRIANGLES;

    return 1;
}
